﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Info;
using Microsoft.Phone.Shell;
using Info.Resources;

namespace Info
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private string GetBasicScreenInfo()
        {
            var width = App.Current.Host.Content.ActualWidth;
            var height = App.Current.Host.Content.ActualHeight;
            var scaleFactor = (double)App.Current.Host.Content.ScaleFactor / 100d;

            return String.Format("{0} x {1}; {2:0.0} scale factor", width, height, scaleFactor);
        }

private string GetExtendedScreenInfo()
{
    object temp;
    if (!DeviceExtendedProperties.TryGetValue("PhysicalScreenResolution", out temp))
        return "not available, sorry";

    var screenResolution = (Size)temp;

    // Can query for RawDpiY as well, but it will be the same value
    if (!DeviceExtendedProperties.TryGetValue("RawDpiX", out temp) || (double)temp == 0d)
        return "not available, sorry";

    var dpi = (double)temp;
    var screenDiagonal = Math.Sqrt(Math.Pow(screenResolution.Width / dpi, 2) +
                Math.Pow(screenResolution.Height / dpi, 2));

    var width = App.Current.Host.Content.ActualWidth;

    return String.Format("{0} x {1}; {2:0.0#} raw scale; {3:0.0}\"", screenResolution.Width, screenResolution.Height, screenResolution.Width / width, screenDiagonal);
}

        void GetScreenInfoClick(object sender, RoutedEventArgs e)
        {
            BasicInfo.Text = GetBasicScreenInfo();
            ExtendedInfo.Text = GetExtendedScreenInfo();
        }
    }
}